'use strict';

var cc = require('ceci-core');
var chans = require('./channels');


function Multicast(inch) {
  this.channel = inch;
  this.pending = chans.chan();
  this.taps = [];
}

Multicast.prototype.run = function() {
  cc.go(wrapGenerator.mark(function() {
    var result, val, i;

    return wrapGenerator(function($ctx0) {
      while (1) switch ($ctx0.next) {
      case 0:
        $ctx0.next = 2;
        return chans.select(this.channel, this.pending);
      case 2:
        result = $ctx0.sent;
        val = result.value;

        if (!(val === undefined)) {
          $ctx0.next = 10;
          break;
        }

        delete $ctx0.thrown;
        $ctx0.next = 23;
        break;
      case 10:
        if (!(result.channel === this.channel)) {
          $ctx0.next = 20;
          break;
        }

        i = 0;
      case 12:
        if (!(i < this.taps.length)) {
          $ctx0.next = 18;
          break;
        }

        $ctx0.next = 15;
        return chans.push(this.taps[i], val);
      case 15:
        ++i;
        $ctx0.next = 12;
        break;
      case 18:
        $ctx0.next = 21;
        break;
      case 20:
        if (val[1])
          this.taps.push(val[0]);
        else {
          i = this.taps.indexOf(val[0]);
          if (i >= 0)
            this.taps.splice(i, 1);
        }
      case 21:
        $ctx0.next = 0;
        break;
      case 23:
      case "end":
        return $ctx0.stop();
      }
    }, this);
  }).bind(this));
};

exports.multicast = function(inch) {
  var mc = new Multicast(inch);
  mc.run();
  return mc;
};

exports.tap = function(mc, ch) {
  return chans.push(mc.pending, [ch, true]);
};

exports.untap = function(mc, ch) {
  return chans.push(mc.pending, [ch, false]);
};
